Index: /gli/branches/rtl-gli/gli.bat
===================================================================
--- /gli/branches/rtl-gli/gli.bat	(revision 18350)
+++ /gli/branches/rtl-gli/gli.bat	(revision 18351)
@@ -1,3 +1,6 @@
 @echo off
+color 0A
+pushd "%CD%"
+CD /D "%~dp0"
 set GLILANG=en
 
@@ -15,74 +18,162 @@
 
 :start
-if "%OS%" == "Windows_NT" goto findGSDL
+if "%OS%" == "Windows_NT" goto progName
     :: Invoke a new command processor to ensure there's enough environment space
-    if "%1" == "Second" goto findGSDL
+    if "%1" == "Second" goto progName
         command /E:2048 /C %0 Second %1 %2 %3 %4 %5 %6 %7 %8 %9
         goto done
 
+
+:progName
+if not "%PROGNAME%" == "" goto findGSDL
+	:: otherwise PROGNAME was not set, so default to the Greenstone Librarian Interface (GLI) program
+	if "%GLILANG%" == "es" set PROGNAME=Biblioteca Digital Greenstone
+	if "%GLILANG%" == "fr" set PROGNAME=Bibliothécaire Greenstone
+	if "%GLILANG%" == "ru" set PROGNAME=ÉÎÔÅÒÆÅÊÓ Greenstone
+	:: if the PROGNAME is still not set, then set the language to English
+	if "%PROGNAME%" == "" set PROGNAME=Greenstone Librarian Interface
+
+
+if "%PROGABBR%" == "" set PROGABBR=GLI
+if "%PROGNAME_EN%" == "" set PROGNAME_EN=Greenstone Librarian Interface
+
 :findGSDL
 echo.
-if "%GLILANG%" == "en" echo Greenstone Librarian Interface (GLI)
-if "%GLILANG%" == "en" echo Copyright (C) 2006, New Zealand Digital Library Project, University Of Waikato
-if "%GLILANG%" == "en" echo GLI comes with ABSOLUTELY NO WARRANTY; for details see LICENSE.txt
+if "%GLILANG%" == "en" echo %PROGNAME% (%PROGABBR%)
+if "%GLILANG%" == "en" echo Copyright (C) 2008, New Zealand Digital Library Project, University Of Waikato
+if "%GLILANG%" == "en" echo %PROGABBR% comes with ABSOLUTELY NO WARRANTY; for details see LICENSE.txt
 if "%GLILANG%" == "en" echo This is free software, and you are welcome to redistribute it
 
-if "%GLILANG%" == "es" echo Interfaz de la Biblioteca Digital Greenstone (Greenstone Librarian Interface - GLI)
-if "%GLILANG%" == "es" echo Copyright (C) 2006, New Zealand Digital Library Project, University Of Waikato
-if "%GLILANG%" == "es" echo La Interfaz de la Biblioteca Digital Greenstone NO INCLUYE ABSOLUTAMENTE NINGUNA GARANTÖA.
+if "%GLILANG%" == "es" echo Interfaz de la %PROGNAME% (%PROGNAME_EN% - %PROGABBR%)
+if "%GLILANG%" == "es" echo Copyright (C) 2008, New Zealand Digital Library Project, University Of Waikato
+if "%GLILANG%" == "es" echo La Interfaz de la %PROGNAME% NO INCLUYE ABSOLUTAMENTE NINGUNA GARANTÖA.
 if "%GLILANG%" == "es" echo Para mayor informaci¢n vea los trminos de la licencia en LICENSE.txt
 if "%GLILANG%" == "es" echo Este es un software abierto, por lo que lo invitamos a que lo distribuya de forma gratuita
 
-if "%GLILANG%" == "fr" echo Interface du Bibliothcaire Greenstone (Greenstone Librarian Interface - GLI)
-if "%GLILANG%" == "fr" echo Copyright (C) 2006, New Zealand Digital Library Project, University Of Waikato
-if "%GLILANG%" == "fr" echo GLI est fourni sans AUCUNE GARANTIE; pour des dtails, voir LICENSE.txt
+if "%GLILANG%" == "fr" echo Interface du %PROGNAME% (%PROGNAME_EN% - %PROGABBR%)
+if "%GLILANG%" == "fr" echo Copyright (C) 2008, New Zealand Digital Library Project, University Of Waikato
+if "%GLILANG%" == "fr" echo %PROGABBR% est fourni sans AUCUNE GARANTIE; pour des dtails, voir LICENSE.txt
 if "%GLILANG%" == "fr" echo Ceci est un logiciel libre, et vous tes invit 
  le redistribuer
 
-if "%GLILANG%" == "ru" echo š¡«š®â¥ç­ë© š­â¥àä¥©á Greenstone (Greenstone Librarian Interface - GLI)
-if "%GLILANG%" == "ru" echo Copyright (C) 2006, New Zealand Digital Library Project, University Of Waikato
+if "%GLILANG%" == "ru" echo š¡«š®â¥ç­ë© š­â¥àä¥©á %PROGNAME% (%PROGNAME_EN% - %PROGABBR%)
+if "%GLILANG%" == "ru" echo Copyright (C) 2008, New Zealand Digital Library Project, University Of Waikato
 if "%GLILANG%" == "ru" echo  ­¥ € ¥â   ; €¥â «š á¬. ¢ â¥ªáâ¥ LICENSE.TXT
 if "%GLILANG%" == "ru" echo â® - á¢®¡®€­® à á¯à®áâà ­ï¥¬®¥ ¯à®£à ¬¬­®¥ ®¡¥á¯¥ç¥­š¥ š ë ¬®Š¥â¥ à á¯à®áâà ­ïâì ¥£®
 
 echo.
-::  ---- Determine GSDLHOME ----
+::  ---- Determine path to Greenstone home for GS2 and GS3 ----
 set GSDLPATH=
-
-:: Some users may set the above line manually
-if not "%GSDLPATH%" == "" goto testGSDL
-
-    :: The default location for the GLI is a subdirectory of Greenstone
-    set GSDLPATH=..
-
-    :: If it is set, use the GSDLHOME environment variable 
-    if "%GSDLHOME%" == "" goto testGSDL
-	set GSDLPATH=%GSDLHOME%
+:: Some users may set the above line manually, or it may be set as an argument
+
+set _VERSION=
+if not "%GSDLPATH%" == "" goto getVer
+	:: Otherwise gsdlpath is not yet set
+	:: Check the env vars first 
+	if not "%GSDL3SRCHOME%" == "" goto ver3
+		if not "%GSDLHOME%" == "" goto ver2
+			:: If not set, the default location for the GLI is a subdirectory of Greenstone
+			set GSDLPATH=..
+			goto getVer
+
+:getVer
+call gsdlver.bat %GSDLPATH% %_VERSION% > nul
+if "%_VERSION%" == "1" goto exit
+::if we are running GS2, free up any pre-set GS3 environment variables since we won't need them
+if "%_VERSION%" == "2" set GSDL3SRCHOME=
+if "%_VERSION%" == "2" set GSDL3HOME=
+goto testGSDL
+
+
+:ver3
+set _VERSION=3
+set GSDLPATH=%GSDL3SRCHOME%
+:: if GS2 is now also set, then both GS3 and GS2 are set: 
+:: warn the user that we have defaulted to GS3
+if not "%GSDLHOME%" == "" echo Both Greenstone 2 and Greenstone 3 environments are set.
+if not "%GSDLHOME%" == "" echo It is assumed you want to run Greenstone 3.
+if not "%GSDLHOME%" == "" echo If you want to run Greenstone 2, please unset the
+if not "%GSDLHOME%" == "" echo environment variable GSDL3SRCHOME before running GLI.
+if not "%GSDLHOME%" == "" echo.
+goto testGSDL
+
+
+:ver2
+set _VERSION=2
+set GSDLPATH=%GSDLHOME%
+::free up the GS3 environment variables since we are running GS2 and don't need them
+set GSDL3SRCHOME=
+set GSDL3HOME=
+goto testGSDL
+
 
 :testGSDL
-:: Check that the Greenstone installation looks OK
-if "%GLILANG%" == "en" echo Checking GSDL: %GSDLPATH%
-if "%GLILANG%" == "es" echo Revisando GSDL: %GSDLPATH%
-if "%GLILANG%" == "fr" echo Vrification de GSDL: %GSDLPATH%
-if "%GLILANG%" == "ru" echo à®¢¥àª  GSDL: %GSDLPATH%
-if exist "%GSDLPATH%\setup.bat" goto prepGSDL
-    echo.
-    if "%GLILANG%" == "en" echo The Greenstone installation could not be found, or is incomplete.
-    if "%GLILANG%" == "en" echo Try reinstalling Greenstone then running this script again.
-
-    if "%GLILANG%" == "es" echo No se pudo encontrar la instalaci¢n de Greenstone o est  incompleta.
-    if "%GLILANG%" == "es" echo Trate de reinstalar Greenstone y a continuaci¢n ejecute nuevamente este gui¢n.
-
-    if "%GLILANG%" == "fr" echo L'installation de Greenstone est introuvable ou incomplte. Essayez
-    if "%GLILANG%" == "fr" echo de rinstaller Greenstone et excutez ce script 
- nouveau.
-
-    if "%GLILANG%" == "ru" echo ­áâ ««ïæšï Greenstone ­¥ ¡ë«  ­ ©€¥­  š«š ®­  ­¥¯®«­ . ®¯à®¡ã©â¥ ¯®¢â®à­®
-    if "%GLILANG%" == "ru" echo ãáâ ­®¢šâì Greenstone,   § â¥¬ ¢¢¥áâš íâ®â áªàš¯â á­®¢ .
-    goto exit
+set CHECK=1
+call chkinst.bat "%GSDLPATH%" %_VERSION% %GLILANG% %CHECK% > nul
+if "%CHECK%" == "1" goto exit
+	:: otherwise installation worked well
+	goto prepGSDL
+
 
 :prepGSDL
-:: Setup Greenstone, unless it has already been done
+:: Greenstone 3 case
+if "%_VERSION%" == "3" goto prepGS3
+
+if not "%_VERSION%" == "2" echo "Greenstone version unknown"
+if not "%_VERSION%" == "2" goto :exit
+
+:: Otherwise, we are dealing with Greenstone 2
+:: Setup Greenstone 2, unless it has already been done
 if not "%GSDLHOME%" == "" goto doneGSDL
-    call "%GSDLPATH%\setup.bat" SetEnv > nul
+    call "%GSDLPATH%\setup.bat" SetEnv
+    goto doneGSDL
+
+
+:prepGS3
+set GSDL2PATH=
+: Some users may set the above line manually
+
+if "%GSDL3SRCHOME%" == "" goto setup3
+	if "%GSDL3HOME%" == "" goto setup3
+		::otherwise
+		goto gs2build
+
+
+:setup3
+:: Setup Greenstone 3, unless it has already been done
+    cd | winutil\setvar.exe GLIDIR > %TMP%\setgli.bat
+    call %TMP%\setgli.bat
+    del %TMP%\setgli.bat
+    cd "%GSDLPATH%"
+    call gs3-setup.bat SetEnv
+    cd %GLIDIR%
+    goto gs2build
+
+
+:gs2build
+	:: If Greenstone version 3 is running, we want to set gsdl2path
+	:: Determine GSDLHOME for GS3 
+	if not "%GSDL2PATH%" == "" goto setupGS2
+		:: GSDL2PATH is not yet set. 
+		:: And if GSDLHOME is not set either, then assume 
+		:: that the gs2build subdir of GS3 exists
+		if "%GSDLHOME%" == "" set GSDL2PATH=%GSDL3SRCHOME%\gs2build
+		if "%GSDLHOME%" == "" goto setupGS2	
+			:: Otherwise GSDLHOME is set, so set GSDL2PATH to GSDLHOME
+			echo GSDLHOME environment variable is set to %GSDLHOME%.	
+			echo Will use this to find build scripts.
+			set GSDL2PATH=%GSDLHOME%
+
+:setupGS2
+set CHECK=1
+call chkinst.bat "%GSDL2PATH%" 2 %GLILANG% %CHECK% > nul
+if "%CHECK%" == "1" goto exit
+	:: otherwise installation worked well
+	:: Setup Greenstone, unless it has already been done
+	if "%GSDLHOME%" == "" call "%GSDL2PATH%\setup.bat" SetEnv
+	:: Either way, we can now dispose of GSDL2PATH
+	set GSDL2PATH=	
+	goto doneGSDL
+
 
 :doneGSDL
@@ -95,11 +186,13 @@
 set PERLPATH=
 
-:: Some users may set the above line manually
+:: Some users may set the above line manually - If you do this, you need to 
+:: make sure that perl is in your path otherwise lucene collections may not 
+:: work
 if not "%PERLPATH%" == "" goto testPerl
 
     :: Check if Perl is on the search path
-    echo %PATH%| winutil\which.exe perl.exe | winutil\setvar.exe PERLPATH > setperl.bat
-    call setperl.bat
-    del setperl.bat
+    echo %PATH%| winutil\which.exe perl.exe | winutil\setvar.exe PERLPATH > %TMP%\setperl.bat
+    call %TMP%\setperl.bat
+    del %TMP%\setperl.bat
     if not "%PERLPATH%" == "" goto testPerl
 
@@ -108,35 +201,40 @@
 
     :: Still haven't found anything, so try looking in the registry (gulp!)
-    type nul > perl.reg
-    regedit /E perl.reg "HKEY_LOCAL_MACHINE\SOFTWARE\Perl"
-    type perl.reg > perl.txt
-    del perl.reg
-
-    winutil\findperl.exe perl.txt | winutil\setvar.exe PERLPATH > setperl.bat
-    del perl.txt
-    call setperl.bat
-    del setperl.bat
+    type nul > %TMP%\perl.reg
+    regedit /E %TMP%\perl.reg "HKEY_LOCAL_MACHINE\SOFTWARE\Perl"
+    type %TMP%\perl.reg > %TMP%\perl.txt
+    del %TMP%\perl.reg
+
+    winutil\findperl.exe %TMP%\perl.txt | winutil\setvar.exe PERLPATH > %TMP%\setperl.bat
+    del %TMP%\perl.txt
+    call %TMP%\setperl.bat
+    del %TMP%\setperl.bat
 
     :: If nothing was found in the registry, we're stuck
     if "%PERLPATH%" == "" goto noPerl
 
+    :: if have found perl in registry, but not in path, then we need to 
+    :: add it to path for lucene stuff.
+    if "%OS%" == "Windows_NT" set PATH=%PATH%;%PERLPATH%
+    if "%OS%" == "" set PATH="%PATH%";"%PERLPATH%"
     goto testPerl
 
 :gsdlPerl
     set PERLPATH=%GSDLHOME%\bin\windows\perl\bin
-
+    	
 :testPerl
 :: Check that a Perl executable has been found
-if "%GLILANG%" == "en" echo Checking Perl: %PERLPATH%
-if "%GLILANG%" == "es" echo Revisando Perl: %PERLPATH%
-if "%GLILANG%" == "fr" echo Vrification de Perl: %PERLPATH%
-if "%GLILANG%" == "ru" echo à®¢¥àª  Perl: %PERLPATH%
-if exist "%PERLPATH%\perl.exe" goto findJava
+if not exist "%PERLPATH%\perl.exe" goto noPerl
+echo Perl:
+echo %PERLPATH%
+echo.
+
+goto findJava
 
 :noPerl
     echo.
-    if "%GLILANG%" == "en" echo The Greenstone Librarian Interface requires perl in order to operate,
-    if "%GLILANG%" == "en" echo but perl could not be detected on your system. Please ensure that perl
-    if "%GLILANG%" == "en" echo is installed and is on your search path, then rerun this script.
+    if "%GLILANG%" == "en" echo The Greenstone Librarian Interface requires Perl in order to operate,
+    if "%GLILANG%" == "en" echo but Perl could not be detected on your system. Please ensure that Perl
+    if "%GLILANG%" == "en" echo is installed and is on your search path, then try again.
 
     if "%GLILANG%" == "es" echo La Interfaz de la Biblioteca Digital Greenstone requiere Perl para poder
@@ -158,51 +256,23 @@
 
 :findJava
-:: ---- Check Java exists ----
-set JAVAPATH=
-
-:: Some users may set the above line manually
-if not "%JAVAPATH%" == "" goto testJava
-
-    :: If it is set, use the JAVA_HOME environment variable
-    if not "%JAVA_HOME%" == "" goto javahome
-
-    :: Check if Java is on the search path
-    echo %PATH%| winutil\which.exe java.exe | winutil\setvar.exe JAVAPATH > setjava.bat
-    call setjava.bat
-    del setjava.bat
-    if not "%JAVAPATH%" == "" goto testJava
-
-    :: Still haven't found anything, so try looking in the registry (gulp!)
-    type nul > jdk.reg
-    regedit /E jdk.reg "HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Development Kit"
-    type jdk.reg > jdk.txt
-    del jdk.reg
-    type nul > jre.reg
-    regedit /E jre.reg "HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Runtime Environment"
-    type jre.reg > jre.txt
-    del jre.reg
-
-    winutil\findjava.exe jdk.txt jre.txt | winutil\setvar.exe JAVAPATH > setjava.bat
-    del jdk.txt
-    del jre.txt
-    call setjava.bat
-    del setjava.bat
-
-    :: If nothing was found in the registry, we're stuck
-    if "%JAVAPATH%" == "" goto noJava
-
-    set JAVAPATH=%JAVAPATH%\bin
-    goto testJava
-
-:javahome
-    set JAVAPATH=%JAVA_HOME%\bin
-
-:testJava
-:: Check that a Java executable has been found
-if "%GLILANG%" == "en" echo Checking Java: %JAVAPATH%
-if "%GLILANG%" == "es" echo Revisando Java: %JAVAPATH%
-if "%GLILANG%" == "fr" echo Vrification de Java: %JAVAPATH%
-if "%GLILANG%" == "ru" echo à®¢¥àª  Java: %JAVAPATH%
-if exist "%JAVAPATH%\java.exe" goto checkGLI
+    if "%_VERSION%" == "2" (
+		set SEARCH4J_EXECUTABLE=%GSDLHOME%\bin\windows\search4j.exe
+		set HINT=%GSDLHOME%\packages\jre
+	)
+    if "%_VERSION%" == "3" (
+		set SEARCH4J_EXECUTABLE=%GSDL3SRCHOME%\bin\search4j.exe
+		set HINT=%GSDL3SRCHOME%\packages\jre
+	)
+    
+    "%SEARCH4J_EXECUTABLE%" -e -m "1.4.0_00" -p "%HINT%" | winutil\setvar.exe JAVA_EXECUTABLE > %TMP%\set_java_executable.bat
+    call "%TMP%\set_java_executable.bat"
+    del "%TMP%\set_java_executable.bat"
+    
+    if "%JAVA_EXECUTABLE%" == "" goto noJava
+    echo Java:
+    echo %JAVA_EXECUTABLE%
+    echo.
+
+    goto checkGLI
 
 :noJava
@@ -212,17 +282,16 @@
     if "%GLILANG%" == "en" echo Greenstone Librarian Interface.
 
-    if "%GLILANG%" == "es" echo No se pudo localizar una versi¢n apropiada de Java. Usted deber 
+    if "%GLILANG%" == "es" echo No se pudo localizar una versi¢n apropiada de Java. Usted deber 
     if "%GLILANG%" == "es" echo instalar un Ambiente de Ejecuci¢n Java (versi¢n 1.4 o superior)
     if "%GLILANG%" == "es" echo antes de correr la Interfaz de la Biblioteca Digital Greenstone.
 
-    if "%GLILANG%" == "fr" echo Une version adquate de Java n'a pas pu tre localise. Vous devez
-    if "%GLILANG%" == "fr" echo installer un Java Runtime Environment (version 1.4 ou suprieur)
-    if "%GLILANG%" == "fr" echo avant de dmarrer Greenstone Librarian Interface.
-
-    if "%GLILANG%" == "ru" echo ¥ ã€ «®áì ®¯à¥€¥«šâì ¬¥áâ®­ å®Š€¥­š¥ á®®â¢¥âáâ¢ãîé¥© ¢¥àášš Java.
-    if "%GLILANG%" == "ru" echo ë €®«Š­ë ãáâ ­®¢šâì Java Runtime Environment (¢¥àášî 1.4 š«š ¢ëè¥) ¯¥à¥€ ¢¢®€®¬
-    if "%GLILANG%" == "ru" echo ¡š¡«š®â¥ç­®£® š­â¥àä¥©á  Greenstone.
+    if "%GLILANG%" == "fr" echo Une version ad?quate de Java n'a pas pu ?tre localis?e. Vous devez
+    if "%GLILANG%" == "fr" echo installer un Java Runtime Environment (version 1.4 ou sup?rieur)
+    if "%GLILANG%" == "fr" echo avant de d?marrer Greenstone Librarian Interface.
+
+    if "%GLILANG%" == "ru" echo ¥ ã «®áì ®¯à¥¥«âì ¬¥áâ®­ å®¥­¥ á®®â¢¥âáâ¢ãîé¥© ¢¥àá Java.
+    if "%GLILANG%" == "ru" echo ?ë ®«­ë ãáâ ­®¢âì Java Runtime Environment (¢¥àáî 1.4 « ¢ëè¥) ¯¥à¥ ¢¢®®¬
+    if "%GLILANG%" == "ru" echo ¡¡«®â¥ç­®£® ­â¥àä¥©á  Greenstone.
     goto exit
-
 
 :checkGLI
@@ -246,11 +315,44 @@
 
 :runGLI
+
+if not "%_VERSION%" == "" (
+    echo Greenstone Major Version:
+	echo %_VERSION%
+	echo.
+)
+
+if not "%GSDL3SRCHOME%" == "" (
+    echo GSDL3SRCHOME:
+    echo %GSDL3SRCHOME%
+	echo.
+)
+
+if not "%GSDL3HOME%" == "" (
+    echo GSDL3HOME:
+    echo %GSDL3HOME%
+	echo.
+)
+
+if not "%GSDLHOME%" == "" (
+    echo GSDLHOME:
+    echo %GSDLHOME%
+	echo.
+)
+
+:: ---- Explain how to bypass Imagemagick and Ghostscript bundled with Greenstone if needed ----
+echo.
+if exist "%GSDLHOME%\bin\windows\ghostscript\bin\*.*" echo GhostScript bundled with Greenstone will be used, if you wish to use the version installed on your system (if any) please go to %GSDLHOME%\bin\windows and rename the folder called ghostscript to something else.
+echo.
+echo.
+if exist "%GSDLHOME%\bin\windows\imagemagick\*.*" echo ImageMagick bundled with Greenstone will be used, if you wish to use the version installed on your system (if any) please go to %GSDLHOME%\bin\windows and rename the folder called imagemagick to something else.
+echo.
+echo.
+
+
 :: ---- Finally, run the GLI ----
-echo.
-
-if "%GLILANG%" == "en" echo Running the Greenstone Librarian Interface...
-if "%GLILANG%" == "es" echo Ejecutando la Interfaz de la Biblioteca Digital Greenstone...
-if "%GLILANG%" == "fr" echo Excution de Greenstone Librarian Interface
-if "%GLILANG%" == "ru" echo ¥ªãéš© ¡š¡«š®â¥ç­ë© š­â¥àä¥©á Greenstone...
+if "%GLILANG%" == "en" echo Running the %PROGNAME%...
+if "%GLILANG%" == "es" echo Ejecutando la %PROGNAME%...
+if "%GLILANG%" == "fr" echo Excution de %PROGNAME%
+if "%GLILANG%" == "ru" echo ¥ªãéš© ¡š¡«š %PROGNAME%...
 
 :: -Xms32M          To set minimum memory
@@ -261,11 +363,35 @@
 :: -Xloggc:<file>   Write garbage collection log
 
-if exist "%GSDLHOME%\server.exe" goto localLib 
+
+:: Run GS3 if version = 3
+if "%_VERSION%" == "3" "%JAVA_EXECUTABLE%" -cp classes/;GLI.jar;lib/apache.jar;lib/qfslib.jar org.greenstone.gatherer.GathererProg -gsdl %GSDLHOME% -gsdlos %GSDLOS% -gsdl3 %GSDL3HOME% -gsdl3src %GSDL3SRCHOME% -perl %PERLPATH% %1 %2 %3 %4 %5 %6 %7 %8 %9
+if "%_VERSION%" == "3" goto finRun
+
+:: Run GS2 since version is 2:
+:: if FLI is running, we don't want the local Greenstone library server running
+if "%PROGABBR%" == "FLI" goto webLib
+	:: Else we're running GLI, so we want the local Greenstone library server (if server.exe exists, otherwise it will be webLib)
+	if exist "%GSDLHOME%\server.exe" goto localLib 
 
 :webLib
-    "%JAVAPATH%\java" -Xmx128M -cp classes/;GLI.jar;lib/apache.jar;lib/qfslib.jar org.greenstone.gatherer.GathererProg -gsdl %GSDLHOME% -gsdlos %GSDLOS% -perl %PERLPATH% %1 %2 %3 %4 %5 %6 %7 %8 %9
-
-    if ERRORLEVEL 2 goto webLib
-
+    "%JAVA_EXECUTABLE%" -Xmx128M -cp classes/;GLI.jar;lib/apache.jar;lib/qfslib.jar org.greenstone.gatherer.GathererProg -gsdl %GSDLHOME% -gsdlos %GSDLOS% -perl %PERLPATH% %1 %2 %3 %4 %5 %6 %7 %8 %9
+    if ERRORLEVEL 2 if not "%localLibFailed%" == "true" (
+        echo webLib failed, going to localLib
+		set webLibFailed=true
+        goto localLib
+    )
+    goto finRun	
+
+:localLib
+    "%JAVA_EXECUTABLE%" -Xmx128M -cp classes/;GLI.jar;lib/apache.jar;lib/qfslib.jar org.greenstone.gatherer.GathererProg -gsdl %GSDLHOME% -gsdlos %GSDLOS% -perl %PERLPATH% -local_library %GSDLHOME%\server.exe %1 %2 %3 %4 %5 %6 %7 %8 %9
+    if ERRORLEVEL 2 if not "%webLibFailed%" == "true" (
+        echo localLib failed, going to webLib
+        set localLibFailed=true
+        goto webLib
+    )
+    goto finRun
+
+
+:finRun
     if "%GLILANG%" == "en" echo Done!
     if "%GLILANG%" == "es" echo ­Hecho!
@@ -274,21 +400,15 @@
     goto done
 
-:localLib
-    "%JAVAPATH%\java" -Xmx128M -cp classes/;GLI.jar;lib/apache.jar;lib/qfslib.jar org.greenstone.gatherer.GathererProg -gsdl %GSDLHOME% -gsdlos %GSDLOS% -perl %PERLPATH% -local_library %GSDLHOME%\server.exe %1 %2 %3 %4 %5 %6 %7 %8 %9
-
-    if ERRORLEVEL 2 goto localLib
-
-    if "%GLILANG%" == "en" echo Done!
-    if "%GLILANG%" == "es" echo ­Hecho!
-    if "%GLILANG%" == "fr" echo Termin!
-    if "%GLILANG%" == "ru" echo ë¯®«­¥­®!
-    goto done
 
 :exit
 echo.
 pause
+color 07
+popd
 
 :done
 :: ---- Clean up ----
 set PERLPATH=
-set JAVAPATH=
+set JAVA_EXECUTABLE=
+color 07
+popd
